//
//  Helper.h
//  yoUni
//
//  Created by 韦瑀 on 2019/3/25.
//  Copyright © 2019 韦瑀. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

typedef void(^MasonryBlock)(MASConstraintMaker *make);

@interface Helper : NSObject

+ (instancetype)sharedInstance;


/**
 创建UIButton
 */
- (UIButton *)buttonWithSuperView:(nullable UIView *)superView andNormalTitle:(nullable NSString *)normalTitle andNormalTextColor:(nullable UIColor *)normalTextColor andTextFont:(nullable UIFont *)font andNormalImage:(nullable UIImage *)normalImage backgroundColor:(nullable UIColor *)backgroundColor addTarget:(nullable id)target action:(nullable SEL)action forControlEvents:(UIControlEvents)controlEvents andMasonryBlock:(nullable MasonryBlock)masonryBlock;

/**
 创建UILabel
 */
-(UILabel *)labelWithSuperView:(nullable UIView *)superView backgroundColor:(nullable UIColor *)backgroundColor text:(nullable NSString *)text textAlignment:(NSTextAlignment)textAlignment textColor:(nullable UIColor *)textColor font:(nullable UIFont *)font numberOfLines:(NSInteger)numberOfLines andMasonryBlock:(nullable MasonryBlock)masonryBlock;

/**
 创建UITextField
 */
- (UITextField *)textFieldWithSuperView:(nullable UIView *)superView textAlignment:(NSTextAlignment)textAlignment fontSize:(CGFloat)fontSize textColor:(nullable UIColor *)textColor backgroundColor:(nullable UIColor *)backgroundColor placeholder:(nullable NSString *)placeholder placeholderColor:(nullable UIColor *)placeholderColor placeholderFont:(CGFloat)placeholderFont andMasonryBlock:(nullable MasonryBlock)masonryBlock;

/**
 创建UITextView
 */
- (UITextView *)textViewWithSuperView:(nullable UIView *)superView textAlignment:(NSTextAlignment)textAlignment fontSize:(CGFloat)fontSize textColor:(nullable UIColor *)textColor backgroundColor:(nullable UIColor *)backgroundColor andMasonryBlock:(nullable MasonryBlock)masonryBlock;

/**
 创建UIView
 */
- (UIView *)viewWithSuperView:(nullable UIView *)superView backgroundColor:(nullable UIColor *)backgroundColor andMasonryBlock:(nullable MasonryBlock)masonryBlock; 

/**
 创建UIImageView
 */
- (UIImageView *)imageViewWithSuperView:(nullable UIView *)superView backgroundColor:(nullable UIColor *)backgroundColor image:(nullable UIImage *)image andMasonryBlock:(nullable MasonryBlock)masonryBlock;


- (void)dispatchTime:(NSTimeInterval)time inMainQueueAfter:(void(^)(void))block;

@end

NS_ASSUME_NONNULL_END
